//+------------------------------------------------------------------+
//|                                                AltTradeTypes.mqh |
//|                                                        Jay Davis |
//|                                                 512jay.github.io |
//+------------------------------------------------------------------+
#property copyright "Jay Davis"
#property link      "512jay.github.io"
input group "||---------- Inactive Inputs For Future Use -----------"

enum InstrumentTypes {
Equity,
Future,
Option
};
enum OptionsTypes {
writing,
buying
};
enum ExpiryTypes {
Weekly,
Monthy
};
input InstrumentTypes InstrumentType = Equity; // Instrument Types
input string FuturesTradingSymbol = NULL; // Futures Trading Symbol
input OptionsTypes OptionsType = buying; // Options Type
input double StrikePrice = -100; // Strike Price.
input ExpiryTypes Expires = Weekly; // Weekly or Monthly Expiry

/*
1. Instrument Type :: Futures or Options
2. Trading Symbol :: If futures the we will specify, If Options then we calculate it
3. Options Type :: writing or buying
4. Strike Price ::  to be input , -100 , -50 , 50 , 100, 150 ( to calculate out of the money or in the money)
*/
//+------------------------------------------------------------------+
//| defines                                                          |
//+------------------------------------------------------------------+
// #define MacrosHello   "Hello, world!"
// #define MacrosYear    2010
//+------------------------------------------------------------------+
//| DLL imports                                                      |
//+------------------------------------------------------------------+
// #import "user32.dll"
//   int      SendMessageA(int hWnd,int Msg,int wParam,int lParam);
// #import "my_expert.dll"
//   int      ExpertRecalculate(int wParam,int lParam);
// #import
//+------------------------------------------------------------------+
//| EX5 imports                                                      |
//+------------------------------------------------------------------+
// #import "stdlib.ex5"
//   string ErrorDescription(int error_code);
// #import
//+------------------------------------------------------------------+
