//+------------------------------------------------------------------+
//|                                                        logic.mqh |
//|                                                        Jay Davis |
//|                                                 512jay.github.io |
//+------------------------------------------------------------------+
#property copyright "Jay Davis"
#property link      "512jay.github.io"
/*


So there are following types of messages ::
1. EA NickName :: Pre-Condition Fulfilled
2. EA NickName :: BUY / SELL Initiated with Target / Stop Loss (if any) on a X min Chart at a time frame
3. EA NickName :: SL Modified
4. EA NickName ::  BUY / SELL Closed With Returns at a time frame

Four message types for signal EAs.
#1 Message used when EA generates an order signal. 
EA Nick :: OrderType Condition fulfilled for Lots of Symbol @Price On (special message) at TimeStamp

#2 Message used when EA sends the order.  
NickNameForEA ::Type Initiated for Lots of Symbol @  Price, On (special message) at TimeStamp  c: order comment

#3 Message used when EA modifies the stoploss.
NickNameForEA :: SL Modified for Lots of Symbol to Price, Left Over SL now is (Current Price - Stop Loss) at TimeStamp

#4 is used when closing an order.
NickNameForEA ::  Symbol  closed @Price at TimeStamp with return of Profit

Two message types for copier.
DatabaseName :: OrderType for Lots of Symbol @ Price :: SUCCESS AT TimeStamp
DatabaseName :: OrderType for Lots of Symbol @ Price :: FAIL :: (ERROR MSG) TimeStamp
*/